/* 
  BE n1 - Base de donnes
  Dfinition de la classe BaseDonnees
  2001-10-05, Mathieu Goutelle
*/

#ifndef BD
#define BD

#include <stdio.h>
#include <stdlib.h>
#include "employe.h"

// nbre de paquets disponibles (fix par la fonction de hachage)
#define nb_paq 512
// taille d'un paquet
#define taille_paq nb_art*64
// Dfinition de l'article vide : 64 espaces
#define article_vide "                                                                "

class BaseDonnees {
 private:
  char *nom_fic;      // nom du fichier contenant la base de donnes
  char *nom_fic_ini;  // nom du fichier contenant les infos de dbordement et de remplissage
  int nb_art;         // nbre d'articles par paquet (10 par dfaut)
  int debord[nb_paq]; // indique si un paquet a dbord ou non
  int jauge[nb_paq];  // indique le nombre d'articles dans un paquet

 public:
  // Compare deux articles : le premier peut tre un article "gnrique"
  int Compare_art(char[65], char[65]) const;
  // Calcule le numro de l'article dans le paquet, -1 si non prsent
  int Recherche_ds_paq(int, char[65], FILE*) const;
  // Constucteurs & destructeur
  BaseDonnees();
  BaseDonnees(char*, int);
  BaseDonnees(const BaseDonnees&);
  ~BaseDonnees();
  // Accs aux attributs
  char* Get_nom_fic() const;
  int Get_nb_art() const;
  int a_deborde(int) const;
  int est_vide(int) const;
  int est_plein(int) const;
  // MAJ des attributs
  void Set_nom_fic(char*);
  void Set_nb_art(int);
  void deborde(int);
  void remplit(int);
  void vide(int);
  // Oprations sur la BD
  float tx_debord() const;   // donne la proportion de paquets ayant dbord
  float tx_rempl() const;    // donne la porportion d'articles utiliss dans la base
  int Insertion(const Employe&);
  int Suppression(const Employe&);
  int Modification(const Employe&, const Employe&);
  int Recherche(unsigned int, unsigned int, char, char*) const;
};

#endif
