/* 
  BE n1 - Base de donnes
  Implmentation de la classe Employ
  2001-10-05, Mathieu Goutelle
*/

#include "ctype.h"
#include "iostream.h"
#include "employe.h"

// convertit une chane de caractres en un entier
int str_to_int(char *s, int fin) {
  int i, result;

  for (i=0, result=0; i<fin; i++)
    result = 10*result + (s[i]-'0');

  return result;
}

// Constructeurs divers
Employe::Employe() {
  num_emp = 0;
  salaire = 0;
}

Employe::Employe(int n, int s, char* d, char* v) {
  num_emp = n;
  salaire = s;
  strcpy(dept, d);
  strcpy(ville, v);
}

Employe::Employe(char article[65]) {
  num_emp = str_to_int(article, 5);
  salaire = str_to_int(article+5, 5);

  int i;
  for(i=10; !isspace(article[i]) && i<37; i++) dept[i-10] = article[i];
  dept[i-10] = '\0';

  for(i=37; !isspace(article[i]) && i<64; i++) ville[i-37] = article[i];
  ville[i-37] = '\0';
}

Employe::Employe(const Employe &E) {
  num_emp = E.num_emp;
  salaire = E.salaire;
  strcpy(dept, E.dept);
  strcpy(ville, E.ville);
}

// Destructeur
Employe::~Employe() {
//  delete[] dept;
//  delete[] ville;
}

// Accs aux attributs
int Employe::Get_num_emp() const { return num_emp; }
int Employe::Get_salaire() const { return salaire; }
char* Employe::Get_dept() const { 
  char result[28];
  strcpy(result, dept);
  return result;
}
char* Employe::Get_ville() const {
  char result[28];
  strcpy(result, ville);
  return result;
}

// MAJ des attributs
void Employe::Set_num_emp(int n) { num_emp = n; }
void Employe::Set_salaire(int s) { salaire = s; }
void Employe::Set_dept(char* d) { strcpy(dept, d); }
void Employe::Set_ville(char* v) { strcpy(ville, v); }

// Calcul de la cl de hachage
int Employe::hachage() const {
  return ((num_emp%16)*32 + (salaire%4)*8 + (strlen(dept)%8));
}

// Construction de l'article associ  l'employ
char* Employe::article() const {
  char* result = new char[65];
  result[64] = '\0';

  int i, q;
  for(i=0, q=10000; i<5; i++) {
    result[i] = '0'+(num_emp/q)%10;
    q /= 10;
  };
  for(i=5, q=10000; i<10; i++) {
    result[i] = '0'+(salaire/q)%10;
    q /= 10;
  };

  for(i=0; i<strlen(dept); i++) result[i+10] = dept[i];
  for(i=(strlen(dept)+10); i<37;i++) result[i] = 32; // espace
  for(i=0; i<strlen(ville); i++) result[i+37] = ville[i];
  for(i=(strlen(ville)+37); i<64; i++) result[i] = 32; // espace

  return result;
}

// Surcharge de l'oprateur '<<' pour l'affichage
ostream& operator<<(ostream &f, const Employe &Emp) {
  f<<Emp.num_emp<<' '<<Emp.salaire<<' '<<Emp.dept<<' '<<Emp.ville;
  return f;
};

